#!/usr/local/bin/python2.7

import pandas as pd

def deleteUser(username, token):
	import pyodbc
	username2= getUsernameFromToken(token)
	if username!=username2:
		return "invalid token or username"
	sql = "WITH <https://carre.kmi.open.ac.uk/users/"+username+"> DELETE { ?subject ?predicate ?object }  WHERE { ?subject ?predicate ?object} "
	executeSPARQL(sql, token)
	try:
			c = pyodbc.connect("DSN=Local Virtuoso;UID=USERNAME;PWD=PASSWORD")
	except Exception, e:
			return None

	cursor = c.cursor()
	sql = "delete from DB.DBA.SYS_USERS where U_NAME='"+username+"'"
	print sql
	cursor.execute(sql)
	c.commit()
	c.close()
	return 1


def getEmailByUsername(username):
		import pyodbc
		try:
				c = pyodbc.connect("DSN=Local Virtuoso;UID=USERNAME;PWD=PASSWORD")
		except Exception, e:
				return None

		cursor = c.cursor()
		cursor.execute("select u_e_mail from db.dba.sys_users where u_name='" + username+"'")
		row = cursor.fetchone()
		c.close()
		if row:
				return row[0]
		return None

def getUsernameFromToken(token):
	def getUsernameFromGraphName(graphName):
		rs = graphName
		if "carre.kmi.open.ac.uk/users/" in graphName:
			rs = rs.replace("http://carre.kmi.open.ac.uk/users/","")
			rs = rs.replace("https://carre.kmi.open.ac.uk/users/","")
		return rs


	import pyodbc
	import pandas.io.sql as psql	
	try:
		c = pyodbc.connect("DSN=Local Virtuoso;UID=USERNAME;PWD=PASSWORD")
		cursor = c.cursor()
		sql = """SPARQL SELECT DISTINCT ?g as ?graphName 
			WHERE {
			GRAPH ?g {
				?connection <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_manufacturer> <http://carre.kmi.open.ac.uk/manufacturers/virtuoso> .
				?connection <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_access_token> '"""+token+"""'^^xsd:string .
			}
		}
		"""
		data = psql.read_sql(sql, con=c)
		c.commit()
		c.close()
		if len(data)==0:
			return None
		graphName = data['graphName'].tolist()[0]
	except Exception, e:
		return str(e)
	return getUsernameFromGraphName(graphName)

def getTokensFromUsername(username):
	import pyodbc
	import pandas.io.sql as psql	
	try:
		c = pyodbc.connect("DSN=Local Virtuoso;UID=USERNAME;PWD=PASSWORD")
		cursor = c.cursor()
		sql = """SPARQL SELECT ?token ?token_secret FROM <https://carre.kmi.open.ac.uk/users/"""+username+"""> 
			WHERE {
				?connection <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_manufacturer> <http://carre.kmi.open.ac.uk/manufacturers/virtuoso> .
				?connection <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_access_token> ?token .
				?connection <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_access_token_secret> ?token_secret .
			}
		"""
		data = psql.read_sql(sql, con=c)
		c.commit()
		c.close()
		token = data['token'].tolist()[0]
		token_secret = data['token_secret'].tolist()[0]
	except Exception, e:
		return str(e)
	return token, token_secret

def authenticate(username, password):
	import pyodbc
	import pandas.io.sql as psql	
	try:
		c = pyodbc.connect("DSN=Local Virtuoso;UID=" + username + ";PWD=" + password)
		cursor = c.cursor()
		sql = """SPARQL SELECT ?token ?token_secret FROM <https://carre.kmi.open.ac.uk/users/"""+username+"""> 
			WHERE {
				?connection <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_manufacturer> <http://carre.kmi.open.ac.uk/manufacturers/virtuoso> .
				?connection <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_access_token> ?token .
				?connection <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_access_token_secret> ?token_secret .
			}
		"""
		data = psql.read_sql(sql, con=c)
		c.commit()
		c.close()
		token = data['token'].tolist()[0]
		token_secret = data['token_secret'].tolist()[0]
	except Exception, e:
		return str(e)
	return token, token_secret

def getApplicationTokens(username):
	import pyodbc
	import pandas.io.sql as psql	
	try:
		c = pyodbc.connect("DSN=Local Virtuoso;UID=USERNAME;PWD=PASSWORD")
		cursor = c.cursor()
		sql = """select b.a_key, b.a_secret,b.a_id from DB.DBA.SYS_USERS a, OAUTH.DBA.APP_REG b where a.u_id = b.a_owner and a.U_NAME='"""+username+"""'"""
		data = psql.read_sql(sql, con=c)
		c.commit()
		c.close()
		key = data['a_key'].tolist()[0]
		secret = data['a_secret'].tolist()[0]
		app_id = data['a_id'].tolist()[0]
	except Exception, e:
		return str(e)
	return key, secret, app_id

def getConsumerKey(token):	
	import pyodbc
	import pandas.io.sql as psql	
	try:
		c = pyodbc.connect("DSN=Local Virtuoso;UID=USERNAME;PWD=PASSWORD")
		cursor = c.cursor()
		sql = """SELECT c.cs_key from DB.DBA.SYS_USERS a, OAUTH.DBA.APP_REG b, OAUTH.DBA.CLI_SESSIONS c where a.u_id = b.a_owner and b.a_key=c.cs_key and c.cs_token='""" + token + """';"""
		data = psql.read_sql(sql, con=c)
		print sql
		c.commit()
		c.close()
		return data
	except Exception, e:
		return str(e)
	return data

def executeSPARQL(sql, token):
	username = getUsernameFromToken(token)
	if username is None:
		print token
		return "invalid token"
	app_key, app_secret, app_id = getApplicationTokens(username)
	token, secret = getTokensFromUsername(username)
	import requests
	from requests_oauthlib import OAuth1
	import oauthlib
	import urllib

	# print "token:", token
	# print "secret:", secret
	# print "app_key:", app_key
	# print "app_secret:", app_secret
	# return

	query = {'query':sql, 'format':'application/sparql-results+json'}
	query = urllib.urlencode(query)
	# url = "http://carre.kmi.open.ac.uk:8890/oauth/sparql.vsp?query=select%20distinct%20%3FConcept%20where%20%7B%5B%5D%20a%20%3FConcept%7D%20LIMIT%20100&debug=on&default-graph-uri="
	url = "http://carre.kmi.open.ac.uk:8890/oauth/sparql.vsp?"+ query + "&debug=on&default-graph-uri="

	client = oauthlib.oauth1.Client(client_key=app_key, resource_owner_key=token,resource_owner_secret=app_secret,signature_type=oauthlib.oauth1.SIGNATURE_TYPE_QUERY)
	uri, headers, body = client.sign(url)

	response = requests.get(uri)
	# return uri
	import json
	data = json.loads(response.content)
	data = data['results']['bindings']
	return data
